#ifndef h_SensorSignature_h
#define h_SensorSignature_h

// The signature used for each sensor type
#define S_Length    16

struct signature
{
    int i2c_reg_addr[S_Length];
    int i2c_ro_value[S_Length];
    int signature_length;
    int sensor_id;
};

/* symbolic constants for supported sensor types */
/* Those declarations are now in each sensor file */
/* enum {
	CS2102,
	CS2103,
	HDCS1020,
	HDCS2020,
	ICM102A,
	ICM105A,
	HV7121B,
	HV7131B,
	PB0111,
	PB0330,
	PAS106B,
	PAS202B,
	OVCIF,
	OV7620,
	TAS5110B,
	TAS5130C
} supported_sensors;
*/

#endif
