#include "zc030x_main.h"
/*definetely needed */
#include <linux/module.h>
#include <linux/init.h>
#include <linux/kernel.h>
#include <linux/sched.h>
#include <linux/usb.h>
 
/*questionably needed */
#include <linux/fs.h>
#include <linux/vmalloc.h>
#include <linux/string.h>
#include <linux/mman.h>
#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 0)
#include <linux/wrapper.h>
#endif
#include <linux/signal.h>
#include <linux/errno.h>
#include <linux/poll.h>
#include <linux/slab.h>
#include <linux/fcntl.h>
#include <linux/spinlock.h>
#include <linux/list.h>
#include <linux/smp_lock.h>

#define IMAGE_WIDTH 320
#define IMAGE_HEIGHT 232


void fixframe (__u8* frame){
	__u32 adif;
	__u32 tdif[IMAGE_WIDTH];
	int rollcol;
	int offset;
	__u32 rollcoldif;
	int i;
	int j;
	__u8* p1;
	__u8* p2;

	__u32* p3;
	__u32* p4;
	
	int lineoffset;
	memset (tdif, 0, IMAGE_WIDTH * 4);
	for (j = IMAGE_HEIGHT * 3 / 4; j < IMAGE_HEIGHT; j++){
		lineoffset = IMAGE_WIDTH * j;
		for (i = IMAGE_WIDTH / 2; i < IMAGE_WIDTH; i++){
			p1 = frame + (lineoffset + i - 1) * 3;
			p2 = frame + (lineoffset + i) * 3;
			adif = *p1 - *p2;
			p1++; p2++;
			adif += *p1 - *p2;
			p1++; p2++;
			adif += *p1 - *p2;
			tdif[i] += (adif * adif);
		}
	}
	rollcoldif = 0;
	rollcol = IMAGE_WIDTH;
	for (i = 0; i < IMAGE_WIDTH; i++){
		if (tdif[i] > rollcoldif){
			rollcol = i;
			rollcoldif = tdif[i];
		}
	}
	offset = IMAGE_WIDTH - rollcol - 1;
	PDEBUG(1, "image appears to be %d pixel shifted\n", offset);
	for (i = IMAGE_WIDTH * IMAGE_HEIGHT; i >= 0; i--){
		p3 = (__u32*)frame + i;
		p4 = (__u32*)((__u8*)frame + offset) + i;
		*p4 = *p3;
	}
}

